
package jcm.indata;
import java.io.*;
import java.util.*;
import static jcm.core.report.*;
import jcm.core.tls.fileio;

public class DataConvertor_WEO {
    
    
    public static void main(String[] args) {
    String[] outf_type={"gdp_mer", "gdp_ppp"}, field={"NGDPD", "PPPGDP"};
    String[]  info_type={"MER, current US dollars", "PPP, current international dollars" };

  for (int f=0; f<2; f++) {
        
    File inf=new File("/climate/data/economy/weo/WEOApr2009all.csv");
	File outf=new File("/java/jcm/jcm-svn/src/data/hist/WEO"+outf_type[f]+".csv");
	String header="GDP data, "+info_type[f]+", field "+field[f]+", from WEO April 2009, from 1980 to 2014 (estimated after 2008, or earlier depending on country)\n\n";

    /*
	 Note: the field PPPGDP is purchsing power parity current dollars 
	 the field NGDPD uses market exchange rates to convert to current dollars, including some projected exchange rates (see notes in table)
	(need to correct both using the deflator from US to get 2000$)  - this is easier to join to other data such as PWT
	(note: if  NGDPD = my * ex (=uy/my),  => uy , so  * u0/uy => u0 - same as if take m0 * ex0 (=u0/m0)	 

     REMEMBER TO UPDATE THE DEFLATOR! 
     and to lengthen the curveset and future_start year  in JCM if applicable
     both in histsocdata and change fsygdp in loopcalc for use by popgdp

     */

	try {
	    InputStream is= new FileInputStream(inf);
	    LineNumberReader lnr=new LineNumberReader(new BufferedReader(new InputStreamReader(is)));
	    StringTokenizer st;	String s;
	    List<String> as=new ArrayList();
	    List<String> a= new ArrayList();
	    String b;
	    
	    try {
		while ((s=lnr.readLine())!=null) {
		    st = new StringTokenizer(s, "\t");
		    a.clear();
		    while (st.hasMoreTokens()) a.add(st.nextToken().trim());
		    if (a.size()>2 && a.get(2).equals(field[f])) {
             //note columns => from 1980 to 2014
			b=a.get(3).replace("\"", "");
            if (b.endsWith("Ivoire")) b="Cote d'Ivoire";
            if (b.endsWith("ncipe")) b="Sao Tome and Principe";
            for (int i=9; i<44; i++) b+="\t"+a.get(i).replace(",", "").replace("\"", "");
			b+="\n";
			as.add(b);
		    }
		}//while
	    } catch (IOException e) { deb(e); }
	    
	    is.close();
	    
	    FileWriter fw= new FileWriter(outf);
	    
	    fw.write(header);
	    for (String os : as)  fw.write(os);
	    fw.close();
	    
	} catch (IOException e) { deb(e); }
	
    }
    } //loop mer & ppp
} //end class
/*
 Code is a variant of load-tab
 but to avoid huge memory use need processing during loading, => need specialised method in the middle.
 could pass an object that has a usedataitem() method?
 
 */