
package jcm.mod.regimp;
import java.awt.Color;
import javax.swing.JLabel;
import jcm.core.*;
import jcm.core.par.*;
import jcm.core.cur.*;
import jcm.core.reg.*;
import jcm.core.ob.*;
import jcm.gui.nav.filter;
import jcm.mod.cli.glotemp;
import jcm.gui.plot.mapplot;

import jcm.gui.gen.processdialog;
import jcm.gui.nav.showpan;
import jcm.gui.plot.*;
import static jcm.gui.gen.colfont.*;
import static jcm.core.complexity.*;
import static jcm.core.report.*;


public class regcli extends module implements Runnable,  colormap {
    
    
    public void setinteractions() {
	setaffectedby(gm(glotemp.class), scale.istrue());
	setaffectedby(scaleyear, scale.istrue());
    }
    
    public String[]
	    datasets={	"had3_A2_80", "had3_A2_50", "had3_A2_20", "hhgsax80", "hhgsax20", "eegga180", "gggsa150", "jjgsa180", "basehad3", "baseline", "both1", "both2", "ratio1", "ratio2"} ,
	    quantities={	"tmp", "tmn", "tmx", "dtr", "pre", "cld", "vap", "wnd", "rad", "slp", "hum", "mix&tmx&tmn&pre", "mix&experimental"},
	    months={	"jan", "feb", "mar", "apr", "may", "jun", "jul", "aug", "sep", "oct", "nov", "dec"}
    ;
    
    complexity[] datacomplex={simplest, normal, normal, normal, normal, normal, normal, normal, simplest, expert, simplest, expert, experimental, experimental};
    complexity[] quantcomplex={simplest, normal, normal, normal, simplest, normal, normal, normal, normal, normal, normal, expert, experimental};
    
    
    public param   dataset=new param("dataset", datasets, "had3_A2_80", datacomplex, complexity.simplest) { public void precalc() { checkdoublerequest(); }   };
    public param   quantity=new param("quantity", quantities, "tmp", quantcomplex, complexity.simplest) {	public void precalc() { checkdoublerequest(); }  };
    public param
	    month=new param("month", months, "jan", complexity.simplest),
	    scale=new param("scaletojcm", false),
	    scaleyear=new param("regcliyear", "yr", 2080, 1750, 2300);
    
    void checkdoublerequest() {//this stops it reloading if menu requests same thing twice
	if (!(oldqd.equals(dataset.chosenname()+quantity.chosenname()))) {
	    oldqd=dataset.chosenname()+quantity.chosenname();
	    gotdata=false;
	}
    }
    
    //******************************
    
    String oldqd="";
    
    //static removed from these booleans, end aug06
    public boolean 	 gotdata=false, ready=false, needtorescale=true, hasresetscale=false;
    
    boolean both, ratio, hadbase;
    public mapdata d1=new mapdata(), d2=new mapdata(), d3=new mapdata(), d4=new mapdata(), d5=new mapdata(), d6=new mapdata();
    public double dataav; //average temp of dataset
    public int om=-1; //old month
    
    //******************************
    public void initsetup() {
	makeland();
	om=-1; //force rescale
	addAction(filter.filtertype.Maps, showpan.pan("Map", mapplot.class, this));
	mycomplexity=complexity.simplest;
	super.initsetup();
    }
    
    //main calculation
    //called by loop after change to parameters or heatflux module
    public void postcalc() {
	ready=false;
	if (quantity.changed) { needtorescale=true; } //so this info survives the end of the loop - needed in getdata thread
	//but while the get data thread is running, resetscale is called from somewhere else!
	if (gotdata) {
	    deb("regcli postcalc gotdata");
	    calc();  if (needtorescale) resetscale();
	}
	if (!gotdata) {
	    processdialog pd= new processdialog(this, "Loading GCM Data", new JLabel("<html>Loading GCM Data<p>please wait..."));
	}
    }
    
    public void run() {
	loop.waitUntilLoopDone();
	deb("regcli getdata");
	getdata();
	om=-1;
	calc();  if (needtorescale) resetscale(); //shouldn't be necessary since postcalc does same  - but seems to help to do it twice
	deb("regcli run calls loop go");
	changed=true;
	//call loop to make colorscale reset (*precalc*), then map replot
	loop.golater("RegCli Run", false);
//	loop.gonow(false); // can cause deadlock
    }
    
    
    public void calc() {
	
	if (om!=month.getchosenindex()) om=month.getchosenindex();
	
	//note below is inefficient: don't always need to restore *and* scale
	if (quantity.chosenname().startsWith("mix")) {
	    if (both || ratio) {
		d1.restore(om); d2.restore(om); d3.restore(om); d4.restore(om); d5.restore(om); d6.restore(om);
		if (scale.istrue()) {	d4.scaledata(modelav()/dataav); d5.scaledata(modelav()/dataav); d6.scaledata(modelav()/dataav); }
		combine(d1, d1,d4); combine(d2, d2,d5); combine(d3, d3, d6);
	    } else {
		d1.restore(om); d2.restore(om); d3.restore(om);
		if (scale.istrue()  && !(dataset.chosenname().startsWith("base"))) {	d1.scaledata(modelav()/dataav); d2.scaledata(modelav()/dataav); d3.scaledata(modelav()/dataav); }
	    }
	    if (quantity.chosen=="mix&experimental") mix(d1, d1,d2);
	} else { //NOT MIX
	    if (both || ratio) {
		d2.restore(om); d1.restore(om);
		if(scale.istrue()) d2.scaledata(modelav()/dataav);
		if (!gm(regseacli.class).ratiochangebase.istrue()) combine(d1, d1,d2);
	    } else {
		d1.restore(om);
		if(scale.istrue()  && !(dataset.chosenname().startsWith("base"))) d1.scaledata(modelav()/dataav);
	    }
	}
	ready=true;
    } //end calc
    
    //combine change and baseline (both or ratio)
    public void combine(mapdata dest, mapdata d1, mapdata d2) {
	int k,k2;
	for (int i=0; i<d1.nlat; i++) for (int j=0; j<d1.nlon; j++) {
	    k=i*d1.nlon+j;
	    //be careful with doubles and ints below! check by swap += with =
	    k2=(int)(i*((double)d2.nlat/d1.nlat))*d2.nlon+ (int)(j*((double)d2.nlon/d1.nlon));
	    if (mapdata.dud(d1.r[k]) || mapdata.dud(d2.r[k2]) ) dest.r[k]=curve.dud;
	    else dest.r[k]= (ratio ?  d1.r[k]!=0 ? d2.r[k2]/ d1.r[k] : curve.dud : d2.r[k2]+d1.r[k]  );
	}
    }
    
    //load data
    public void getdata() {
	both=dataset.chosenname().startsWith("both"); ratio=dataset.chosenname().startsWith("ratio"); hadbase=dataset.chosenname().endsWith("1");
	gotdata=false;
	//MIX
	//note doesn't combine with ratio
	if (quantity.chosenname().startsWith("mix")) {
	    if(both  || ratio) {
		if(hadbase) {
		    d1.getdata("basehad3", "tmx");
		    d2.getdata("basehad3", "pre");
		    d3.getdata("basehad3", "tmn");
		} else {
		    d1.getdata("baseline", "tmx");
		    d2.getdata("baseline", "pre");
		    d3.getdata("baseline", "tmn");
		}
		d4.getdata("had3_A2_80", "tmx");
		d5.getdata("had3_A2_80", "pre");
		d6.getdata("had3_A2_80", "tmn");
	    } else {
		d1.getdata(dataset.chosenname(), "tmx");
		d2.getdata(dataset.chosenname(), "pre");
		d3.getdata(dataset.chosenname(), "tmn");
	    }
	}
	//END MIX
	
	else {
	    
	    if(both || ratio) {
		d1.getdata((hadbase ? "basehad3" : "baseline") , quantity.chosenname());
		d2.getdata("had3_A2_80", quantity.chosenname());
	    } else {
		d1.getdata(dataset.chosenname(), quantity.chosenname());
	    }
	}
	if (quantity.chosenname()=="tmp") {
	    if (both || ratio) dataav=d2.av;
	    else if (dataset.chosen!="baseline") dataav=d1.av;
	}
	gotdata=true;
    }
    
	/*
	 method to get the average climate from the model
	note the baseline climatology for IPCC-DDC datasets is 1961-1990, below assumes 1975
	but this will give temperatures wrt 1975, regardless of the glotemp baseyear
	should make this consistent later (inc in doc)
	 */
    
    public float modelav() {	return (gm(glotemp.class).avchange.get((int)(scaleyear.val))-gm(glotemp.class).avchange.get(1975)); }
    
    //not currently used
    //public float tempbase() {	return get(glotemp.class).avchange.a[(int)get(glotemp.class).baseyear.getval()-gsy]-get(glotemp.class).avchange.a[0]; }
    
    
    //make land-ocean mask
    public int[] land;
    void makeland() {
	int[] hadoc= {
	    //hadley grid (96*73) , numbers show number of consecutive cells ocean or land (wrap at end)
	    363,4,5,6,78,20,31,2,43,4,2,13,29,7,41,3,6,10,24,1,2,13,28,4,4,5,6,9,11,3,9,25,11,3,6,6,2,7,4,8,10,7,3,37,2,22,2,2,3,6,12,2,1,41,5,21,3,2,4,3,5,2,5,3,1,42,5,19,6,1,4,2,13,3,2,35,2,1,8,18,5,2,22,1,2,31,5,1,16,12,4,4,15,1,3,1,2,31,5,2,17,13,2,5,14,2,1,36,4,1,19,13,1,6,12,40,25,19,14,13,2,23,25,10,1,5,2,1,14,8,3,2,1,23,1,1,24,10,2,4,17,1,2,1,1,3,3,2,1,22,2,1,24,15,16,3,5,8,1,20,3,1,24,14,17,2,8,6,1,17,2,1,2,1,26,12,18,5,7,22,4,2,26,12,19,5,6,23,32,10,19,15,1,19,33,9,19,15,2,18,34,4,22,19,2,14,36,3,22,13,1,5,3,12,37,3,4,1,16,14,1,5,4,3,2,4,39,3,1,1,3,2,14,15,1,3,5,3,3,3,40,4,19,15,1,2,6,2,5,3,2,1,39,2,18,17,8,1,5,3,3,1,39,1,18,18,7,1,5,2,4,1,40,1,1,4,13,17,19,1,41,6,12,3,2,11,14,1,3,1,44,6,12,2,3,10,14,1,2,2,44,7,16,9,15,1,2,2,43,8,16,8,16,2,1,3,4,1,37,10,15,7,17,1,8,2,36,12,13,7,27,2,35,12,13,7,65,11,13,7,25,1,39,10,14,7,2,1,20,3,1,1,37,10,14,7,2,1,19,6,38,9,14,6,3,1,19,7,38,8,14,6,2,1,18,10,37,7,15,6,2,1,18,10,37,6,17,4,22,10,37,6,17,4,22,10,36,6,18,3,23,3,2,5,36,6,50,4,36,5,52,2,37,4,62,1,29,3,62,1,30,2,62,1,31,2,94,2,94,1,95,1,96,1,384,1,29,3,7,16,39,2,24,35,34,3,16,45,32,3,13,48,15,20,10,53,4,29,8,54,5,94,5,330
	};
	land = new int[73*96];
	
	int k=0; int l=-1;
	for (int i=0; i<hadoc.length; i++) {
	    for (int j=0; j<hadoc[i]; j++) {	land[k]=l; k++; }
	    l=-l;
	}
	//check: for (int y=0; y<73; y++) {	System.out.println(); for (int x=0; x<96; x++) System.out.print(1+land[x+y*96]); }
    }//land
    
    
    public void mix(mapdata dest, mapdata d1, mapdata d2) {
	int k;
	for (int i=0; i<d1.nlat; i++) for (int j=0; j<d1.nlon; j++) {
	    k=i*d1.nlon+j;
	    dest.r[k]=16*(
		    4*( d1.r[k]<(d1.av-0.5*d1.sd) ? 0 : d1.r[k]<d1.av ? 1 : d1.r[k]<(d1.av+0.5*d1.sd) ? 2 : 3 )
		    +( d2.r[k]<(d2.av-0.5*d2.sd) ? 0 : d2.r[k]<d2.av ? 1 : d2.r[k]<(d2.av+0.5*d2.sd) ? 2 : 3 )
		    );
	}
    }
    
    
    //*****************************************************
    //for map colorscale
    //note - we want to change  min and range if press rescale or change dataset, but not while adusting the scaletojcm or month
    double min, range;
    public void resetscale() { min=d1.fac*(d1.av-2.0*d1.sd); range= d1.fac*(6.0*d1.sd); if (gotdata) needtorescale=false; hasresetscale=true; deb("resetscale "+min+"-"+(min+range)); }
    public boolean  hasresetscale() { deb("hasresetscale "+hasresetscale); if (hasresetscale) { hasresetscale=false; return true;   } return false; }
    
    public boolean gotscale() { return true; }
    
    public double getmin() { return min; }
    public double getrange() { return range; }
    
    public String getMapInfo(region r) {return units.dp(d1.avg(r), 100f)  + "    "  ; } // -rc.tempbase() //delta "\u0394: "
    
    public float getValue(region r) { return d1.avg(r); }
    
    
    //note: below not currently used
    public Color mixregcolor(region r) {	return mixcolor(d1,d2,d3, d1.avg(r), d2.avg(r), d3.avg(r) ) ; }
    
    public Color mixcolor(mapdata d1, mapdata d2, mapdata d3, float v, float v2, float v3) {
	if (mapdata.dud(v)  || mapdata.dud(v2) || mapdata.dud(v3)) return Color.white; else {
	    int r=(int)((v-(d1.av-2.0*d1.sd))*(128.0/(2.0*d1.sd))); if (r<0) r=0; if (r>255) r=255;
	    int g=(int)(Math.log(1.0+(v2-d2.min)/(d2.av-d2.min)) *256.0 /Math.log(1.0+(3.0*d2.av-d2.min)/(d2.av-d2.min)) ); if (g<0) g=0; if (g>255) g=255;
	    int b=(int)(((d3.av+2.0*d3.sd)-v3)*(128.0/(2.0*d3.sd))); if (b<0) b=0; if (b>255) b=255;
	    return new Color(r,g,b);
	}
    }
    //*****************************************************
    
    
} //end class regcli


//    //not obvious if int version still used
//    public Color getcolor(int i) {
//	if (quantity.chosen.equals("mix&tmx&tmn&pre")) return mixcolor(i);
//	else return getcolor(d1.r[i]);
//    }
//public Color mixcolor(int i) {	return mixcolor(d1,d2,d3, d1.r[i], d2.r[i], d3.r[i]); }

//    //note this is no longer used, because color got from combination of getValue and getColor to account for adjustable colorscale
//    public Color getColor(region r) {
//	if (quantity.chosen.equals("mix&tmx&tmn&pre"))  return mixregcolor(r);
//	else return getColor(getValue(r));
//    }

